/[gentoo-x86]/eclass/kde4-meta.eclass
Gentoo

Diff of /eclass/kde4-meta.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.3 Revision 1.46
1# Copyright 1999-2008 Gentoo Foundation 1# Copyright 1999-2010 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.3 2008/02/24 21:45:39 keytoaster Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/kde4-meta.eclass,v 1.46 2010/12/29 17:06:51 tampakrap Exp $
4# 4#
5# @ECLASS: kde4-meta.eclass 5# @ECLASS: kde4-meta.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# kde@gentoo.org 7# kde@gentoo.org
8# @BLURB: Eclass for writing "split" KDE packages. 8# @BLURB: Eclass for writing "split" KDE packages.
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass provides all necessary functions for writing split KDE ebuilds. 10# This eclass provides all necessary functions for writing split KDE ebuilds.
11# 11#
12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional. 12# You must define KMNAME to use this eclass, and do so before inheriting it. All other variables are optional.
13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY. 13# Do not include the same item in more than one of KMMODULE, KMMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY.
14#
15# NOTE: This eclass uses the SLOT dependencies from EAPI="1" or compatible,
16# hence you must define EAPI="1" in the ebuild, before inheriting any eclasses.
17 14
18inherit multilib kde4-functions kde4-base 15inherit kde4-base versionator
19 16
20EXPORT_FUNCTIONS pkg_setup src_unpack src_compile src_test src_install pkg_postinst pkg_postrm 17EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_test src_install pkg_postinst pkg_postrm
21 18
22if [[ -z ${KMNAME} ]]; then
23 die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild" 19[[ -z ${KMNAME} ]] && die "kde4-meta.eclass inherited but KMNAME not defined - broken ebuild"
24fi
25
26case ${KDEBASE} in
27 kde-base) HOMEPAGE="http://www.kde.org/"
28 LICENSE="GPL-2" ;;
29 koffice) HOMEPAGE="http://www.koffice.org/"
30 LICENSE="GPL-2" ;;
31 *) die "KDEBASE=${KDEBASE} is unsupported." ;;
32esac
33
34debug-print "${BASH_SOURCE} ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - before blockers"
35debug-print "${BASH_SOURCE} ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - before blockers"
36
37# Add a blocker on the package we're derived from
38DEPEND="${DEPEND} !$(get-parent-package ${CATEGORY}/${PN}):${SLOT}"
39RDEPEND="${RDEPEND} !$(get-parent-package ${CATEGORY}/${PN}):${SLOT}"
40
41debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after blockers"
42debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after blockers"
43 20
44# Add dependencies that all packages in a certain module share. 21# Add dependencies that all packages in a certain module share.
45case ${KMNAME} in 22case ${KMNAME} in
46 kdebase|kdebase-workspace|kdebase-runtime) 23 kdebase|kdebase-apps|kdebase-workspace|kdebase-runtime|kdegraphics)
47 DEPEND="${DEPEND} >=kde-base/qimageblitz-0.0.4" 24 COMMONDEPEND+=" >=media-libs/qimageblitz-0.0.4"
48 RDEPEND="${RDEPEND} >=kde-base/qimageblitz-0.0.4"
49 ;; 25 ;;
50 kdepim) 26 kdepim|kdepim-runtime)
51 if [[ ${PN} != kode ]]; then
52 DEPEND="${DEPEND} >=kde-base/kode-${PV}:${SLOT}"
53 RDEPEND="${RDEPEND} >=kde-base/kode-${PV}:${SLOT}"
54 fi
55 case ${PN} in 27 case ${PN} in
56 akregator|kaddressbook|kmail|kmobiletools|knode|knotes|korganizer|ktimetracker) 28 akregator|kaddressbook|kjots|kmail|knode|knotes|korganizer|ktimetracker)
57 IUSE="+kontact" 29 IUSE+=" +kontact"
58 DEPEND="${DEPEND} kontact? ( >=kde-base/kontact-${PV}:${SLOT} )" 30 RDEPEND+=" kontact? ( $(add_kdebase_dep kontact) )"
59 RDEPEND="${RDEPEND} kontact? ( >=kde-base/kontact-${PV}:${SLOT} )"
60 ;; 31 ;;
61 esac 32 esac
62 ;; 33 ;;
63 kdegames) 34 kdegames)
64 if [[ ${PN} != "libkdegames" ]]; then 35 if [[ ${PN} != libkdegames ]]; then
65 DEPEND="${DEPEND} >=kde-base/libkdegames-${PV}:${SLOT}" 36 COMMONDEPEND+=" $(add_kdebase_dep libkdegames)"
66 RDEPEND="${RDEPEND} >=kde-base/libkdegames-${PV}:${SLOT}"
67 fi 37 fi
68 ;; 38 ;;
69 koffice) 39 koffice)
70 case ${PN} in 40 [[ ${PN} != koffice-data ]] && IUSE+=" debug"
71 koffice-libs|koffice-data) : ;; 41 RDEPEND+="
72 *) 42 !app-office/${PN}:0
43 !app-office/koffice:0
44 !app-office/koffice-meta:0
45 "
46 if has openexr ${IUSE//+}; then
47 COMMONDEPEND+=" media-gfx/imagemagick[openexr?]"
48 else
49 COMMONDEPEND+=" media-gfx/imagemagick"
50 fi
51
52 COMMONDEPEND+="
53 dev-cpp/eigen:2
54 media-libs/fontconfig
55 media-libs/freetype:2
56 "
57 if [[ ${PN} != koffice-libs && ${PN} != koffice-data ]]; then
73 DEPEND="${DEPEND} >=app-office/koffice-libs-${PV}:${SLOT}" 58 COMMONDEPEND+=" >=app-office/koffice-libs-${PV}:${SLOT}"
74 RDEPEND="${RDEPEND} >=app-office/koffice-libs-${PV}:${SLOT}" 59 fi
75 ;; 60 ;;
76 esac
77 ;;
78esac 61esac
62
63DEPEND+=" ${COMMONDEPEND}"
64RDEPEND+=" ${COMMONDEPEND}"
65unset COMMONDEPEND
79 66
80debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies" 67debug-print "line ${LINENO} ${ECLASS}: DEPEND ${DEPEND} - after metapackage-specific dependencies"
81debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies" 68debug-print "line ${LINENO} ${ECLASS}: RDEPEND ${RDEPEND} - after metapackage-specific dependencies"
82 69
70# Useful to build kde4-meta style stuff from extragear/playground (plasmoids etc)
71case ${BUILD_TYPE} in
72 live)
73 case ${KMNAME} in
74 extragear*|playground*)
75 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
76 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
77 ;;
78 esac
79 ;;
80esac
81
83# @ECLASS-VARIABLE: KMNAME 82# @ECLASS-VARIABLE: KMNAME
84# @DESCRIPTION: 83# @DESCRIPTION:
85# Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it _before_ inheriting this eclass, 84# Name of the parent-module (e.g. kdebase, kdepim, ...). You _must_ set it
86# (unlike the other parameters), since it's used to set $SRC_URI. 85# _before_ inheriting this eclass, (unlike the other parameters), since it's
86# used to set $SRC_URI.
87 87
88# @ECLASS-VARIABLE: KMMODULE 88# @ECLASS-VARIABLE: KMMODULE
89# @DESCRIPTION: 89# @DESCRIPTION:
90# Specify exactly one subdirectory of $KMNAME here. Defaults to $PN. 90# Specify exactly one subdirectory of $KMNAME here. Defaults to $PN.
91# The subdirectory listed here is treated exactly like items in $KMEXTRA. 91# The subdirectory listed here is treated exactly like items in $KMEXTRA.
96# @ECLASS-VARIABLE: KMNOMODULE 96# @ECLASS-VARIABLE: KMNOMODULE
97# @DESCRIPTION: 97# @DESCRIPTION:
98# If set to "true", $KMMODULE doesn't have to be defined. 98# If set to "true", $KMMODULE doesn't have to be defined.
99# 99#
100# Example usage: If you're installing subdirectories of a package, like plugins, 100# Example usage: If you're installing subdirectories of a package, like plugins,
101# you mark the topsubdirectory (containing the package) as $KMEXTRACTONLY, and set KMNOMODULE="true". 101# you mark the top subdirectory (containing the package) as $KMEXTRACTONLY, and
102if [[ ${KMNOMODULE} != "true" && -z ${KMMODULE} ]]; then 102# set KMNOMODULE="true".
103if [[ -z ${KMMODULE} ]] && [[ ${KMNOMODULE} != true ]]; then
103 KMMODULE=${PN} 104 KMMODULE=${PN}
104fi 105fi
105 106
106# @ECLASS-VARIABLE: KMEXTRA 107# @ECLASS-VARIABLE: KMEXTRA
107# @DESCRIPTION: 108# @DESCRIPTION:
108# All subdirectories listed here will be extracted, compiled & installed. 109# All subdirectories listed here will be extracted, compiled & installed.
109# $KMMODULE is always added to $KMEXTRA. 110# $KMMODULE is always added to $KMEXTRA.
110# If the htmlhandbook USE-flag is set, and if this directory exists, 111# If KDE_HANDBOOK is 'always' or 'optional' and handbook USE-flag is set, and if this
111# then "doc/$KMMODULE" is added to $KMEXTRA. In other cases, this should be 112# directory exists, then "doc/$KMMODULE" is added to $KMEXTRA. If there's additional
112# handled in the ebuild.
113# If the documentation is in a different subdirectory, you should add it to KMEXTRA. 113# documentation in different subdirectories, it should be added to KMEXTRA manually..
114 114
115# @ECLASS-VARIABLE: KMCOMPILEONLY 115# @ECLASS-VARIABLE: KMCOMPILEONLY
116# @DESCRIPTION: 116# @DESCRIPTION:
117# All subdirectories listed here will be extracted & compiled, but not installed. 117# All subdirectories listed here will be extracted & compiled, but not installed.
118 118
119# TODO: better formulation may be needed
119# @ECLASS-VARIABLE: KMEXTRACTONLY 120# @ECLASS-VARIABLE: KMEXTRACTONLY
120# @DESCRIPTION: 121# @DESCRIPTION:
121# All subdirectories listed here will be extracted, but not compiled nor installed. 122# All subdirectories listed here will be extracted, but neither compiled nor installed.
122# This can be used to avoid compilation in a subdirectory of a directory in $KMMODULE or $KMEXTRA 123# This can be used to avoid compilation in a subdirectory of a directory in $KMMODULE or $KMEXTRA
123 124
124# @ECLASS-VARIABLE: KMTARPARAMS 125# @ECLASS-VARIABLE: KMTARPARAMS
125# @DESCRIPTION: 126# @DESCRIPTION:
126# Specify extra parameters to pass to tar, in kde4-meta_src_extract. 127# Specify extra parameters to pass to tar, in kde4-meta_src_extract.
127# '-xpf -j' are passed to tar by default. 128# '-xpf -j' are passed to tar by default.
128 129
129# @FUNCTION: kde4-meta_pkg_setup 130# @FUNCTION: kde4-meta_pkg_setup
130# @DESCRIPTION: 131# @DESCRIPTION:
131# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 132# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in
132# ebuilds. 133# split ebuilds.
133kde4-meta_pkg_setup() { 134kde4-meta_pkg_setup() {
135 debug-print-function ${FUNCNAME} "$@"
136
134 kde4-base_pkg_setup 137 kde4-base_pkg_setup
135} 138}
136 139
137# @FUNCTION: kde4-meta_src_unpack 140# @FUNCTION: kde4-meta_src_unpack
138# @DESCRIPTION: 141# @DESCRIPTION:
139# This function unpacks the source for split ebuilds. See also 142# This function unpacks the source for split ebuilds. See also
140# kde4-meta-src_extract. 143# kde4-meta-src_extract.
141kde4-meta_src_unpack() { 144kde4-meta_src_unpack() {
142 debug-print-function ${FUNCNAME} "$@" 145 debug-print-function ${FUNCNAME} "$@"
143 146
144 if [[ ${KMNAME} = kdepim ]] && \ 147 if [[ ${BUILD_TYPE} = live ]]; then
145 has kontact ${IUSE//+} && \ 148 migrate_store_dir
146 use kontact; then 149 S="${WORKDIR}/${P}"
147 KMEXTRA="${KMEXTRA} kontact/plugins/${PLUGINNAME:-${PN}}" 150 mkdir -p "${S}"
148 KMEXTRACTONLY="${KMEXTRACTONLY} kontact/interfaces/" 151 ESVN_RESTRICT="export" subversion_src_unpack
149 fi 152 subversion_wc_info
150 153 subversion_bootstrap
151 kde4-meta_src_extract 154 kde4-meta_src_extract
152 kde4-meta_change_cmakelists 155 else
156 kde4-meta_src_extract
157 fi
153} 158}
159
160# FIXME: the difference between kde4-meta_src_extract and kde4-meta_src_unpack?
154 161
155# @FUNCTION: kde4-meta_src_extract 162# @FUNCTION: kde4-meta_src_extract
156# @DESCRIPTION: 163# @DESCRIPTION:
157# A function to unpack the source for a split KDE ebuild. 164# A function to unpack the source for a split KDE ebuild.
158# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and KMTARPARAMS. 165# Also see KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and
166# KMTARPARAMS.
159kde4-meta_src_extract() { 167kde4-meta_src_extract() {
160 local tarball tarfile f extractlist 168 debug-print-function ${FUNCNAME} "$@"
161 tarball="${KMNAME}-${PV}.tar.bz2"
162 tarfile="${DISTDIR}"/${tarball}
163 169
164 einfo "Unpacking parts of ${tarball} to ${WORKDIR}" 170 if [[ ${BUILD_TYPE} = live ]]; then
165 171 local rsync_options subdir kmnamedir targetdir
172 # Export working copy to ${S}
173 einfo "Exporting parts of working copy to ${S}"
166 kde4-meta_create_extractlists 174 kde4-meta_create_extractlists
167 175
176 rsync_options="--group --links --owner --perms --quiet --exclude=.svn/"
177
178 # Copy ${KMNAME} non-recursively (toplevel files)
179 rsync ${rsync_options} "${ESVN_WC_PATH}"/${kmnamedir}* "${S}" \
180 || die "${ESVN}: can't export toplevel files to '${S}'."
181 # Copy cmake directory
182 if [[ -d "${ESVN_WC_PATH}/${kmnamedir}cmake" ]]; then
183 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}cmake" "${S}" \
184 || die "${ESVN}: can't export cmake files to '${S}'."
185 fi
186 # Copy all subdirectories
187 for subdir in $(__list_needed_subdirectories); do
188 targetdir=""
189 if [[ $subdir = doc/* && ! -e "$ESVN_WC_PATH/$kmnamedir$subdir" ]]; then
190 continue
191 fi
192
193 [[ ${subdir%/} = */* ]] && targetdir=${subdir%/} && targetdir=${targetdir%/*} && mkdir -p "${S}/${targetdir}"
194 rsync --recursive ${rsync_options} "${ESVN_WC_PATH}/${kmnamedir}${subdir%/}" "${S}/${targetdir}" \
195 || die "${ESVN}: can't export subdirectory '${subdir}' to '${S}/${targetdir}'."
196 done
197
198 if [[ ${KMNAME} = kdebase-runtime && ${PN} != kdebase-data ]]; then
199 sed -i -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
200 "${S}"/CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
201 fi
202 else
203 local abort tarball tarfile f extractlist moduleprefix postfix
204 case ${PV} in
205 4.[45].8[05] | 4.[45].9[023568])
206 # Block for normally packed upstream unstable snapshots
207 KMTARPARAMS+=" --bzip2" # bz2
208 postfix="bz2"
209 ;;
210 *)
211 KMTARPARAMS+=" --bzip2" # bz2
212 postfix="bz2"
213 ;;
214 esac
215 case ${KMNAME} in
216 kdebase-apps)
217 # kdebase/apps -> kdebase-apps
218 tarball="kdebase-${PV}.tar.${postfix}"
219 # Go one level deeper for kdebase-apps in tarballs
220 moduleprefix=apps/
221 KMTARPARAMS+=" --transform=s|apps/||"
222 ;;
223 kdepim)
224 if [[ ${PV} == 4.5.93 ]] ; then
225 tarball="kdepim-4.6beta3.tar.${postfix}"
226 fi
227 ;;
228 *)
229 # Create tarball name from module name (this is the default)
230 tarball="${KMNAME}-${PV}.tar.${postfix}"
231 ;;
232 esac
233
234 # Full path to source tarball
235 tarfile="${DISTDIR}/${tarball}"
236
237 # Detect real toplevel dir from tarball name - it will be used upon extraction
238 # and in __list_needed_subdirectories
239 topdir="${tarball%.tar.*}/"
240
241 ebegin "Unpacking parts of ${tarball} to ${WORKDIR}"
242
243 kde4-meta_create_extractlists
244
168 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \ 245 for f in cmake/ CMakeLists.txt ConfigureChecks.cmake config.h.cmake \
169 AUTHORS COPYING INSTALL README NEWS ChangeLog 246 AUTHORS COPYING INSTALL README NEWS ChangeLog
170 do 247 do
171 extractlist="${extractlist} ${KMNAME}-${PV}/${f}" 248 extractlist+=" ${topdir}${moduleprefix}${f}"
172 done 249 done
173 extractlist="${extractlist} $(__list_needed_subdirectories)" 250 extractlist+=" $(__list_needed_subdirectories)"
174 KMTARPARAMS="${KMTARPARAMS} -j"
175 251
176 pushd "${WORKDIR}" > /dev/null 252 pushd "${WORKDIR}" > /dev/null
177 tar -xpf $tarfile $KMTARPARAMS $extractlist 2> /dev/null 253 [[ -n ${KDE4_STRICTER} ]] && echo tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist}
254 tar -xpf "${tarfile}" ${KMTARPARAMS} ${extractlist} || ewarn "tar extract command failed at least partially - continuing anyway"
178 255
179 # Default $S is based on $P; rename the extracted directory to match $S 256 # Default $S is based on $P; rename the extracted directory to match $S if necessary
180 mv ${KMNAME}-${PV} ${P} || die "Died while moving \"${KMNAME}-${PV}\" to \"${P}\"" 257 mv ${topdir} ${P} || die "Died while moving \"${topdir}\" to \"${P}\""
181 258
182 popd > /dev/null 259 popd > /dev/null
183 kde4-base_src_unpack
184}
185 260
261 eend $?
262
263 # We need to clear it here to make verification below work
264 unset moduleprefix
265
266 if [[ -n ${KDE4_STRICTER} ]]; then
267 for f in $(__list_needed_subdirectories fatal); do
268 if [[ ! -e "${S}/${f#*/}" ]]; then
269 eerror "'${f#*/}' is missing"
270 abort=true
271 fi
272 done
273 [[ -n ${abort} ]] && die "There were missing files."
274 fi
275
276 # We don't need it anymore
277 unset topdir
278 fi
279}
280
281# @FUNCTION: kde4-meta_create_extractlists
282# @DESCRIPTION:
186# Create lists of files and subdirectories to extract. 283# Create lists of files and subdirectories to extract.
187# Also see the descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY, KMEXTRACTONLY and KMTARPARAMS. 284# Also see descriptions of KMMODULE, KMNOMODULE, KMEXTRA, KMCOMPILEONLY,
285# KMEXTRACTONLY and KMTARPARAMS.
188kde4-meta_create_extractlists() { 286kde4-meta_create_extractlists() {
189 debug-print-function ${FUNCNAME} "$@" 287 debug-print-function ${FUNCNAME} "$@"
190 288
191 if has htmlhandbook ${IUSE//+} && use htmlhandbook; then 289 # Add default handbook locations
290 # FIXME - legacy code - remove when 4.4.5 is gone or preferrably port 4.4.5.
291 if ! slot_is_at_least 4.5 ${SLOT} && has handbook ${IUSE//+} && use handbook && [[ -z ${KMNOMODULE} ]]; then
192 # We use the basename of $KMMODULE because $KMMODULE can contain 292 # We use the basename of $KMMODULE because $KMMODULE can contain
193 # the path to the module subdirectory. 293 # the path to the module subdirectory.
294 KMEXTRA_NONFATAL+="
295 doc/${KMMODULE##*/}"
296 fi
297
298 # Add default handbook locations
299 if [[ -z ${KMNOMODULE} ]] && { [[ ${KDE_HANDBOOK} = always ]] || { [[ ${KDE_HANDBOOK} = optional ]] && use handbook; }; }; then
194 KMEXTRA="${KMEXTRA} doc/${KMMODULE##*/}" 300 KMEXTRA_NONFATAL+=" doc/${KMMODULE##*/}"
195 fi 301 fi
196 302
197 # Add some CMake-files to KMEXTRACTONLY. 303 # Add some CMake-files to KMEXTRACTONLY.
198 # Note that this actually doesn't include KMEXTRA handling. 304 # Note that this actually doesn't include KMEXTRA handling.
199 # In those cases you should care to add the relevant files to KMEXTRACTONLY 305 # In those cases you should care to add the relevant files to KMEXTRACTONLY
200 case ${KMNAME} in 306 case ${KMNAME} in
201 kdebase) 307 kdebase)
202 KMEXTRACTONLY="${KMEXTRACTONLY} 308 KMEXTRACTONLY+="
203 apps/config-apps.h.cmake 309 apps/config-apps.h.cmake
204 apps/ConfigureChecks.cmake" 310 apps/ConfigureChecks.cmake"
205 ;; 311 ;;
312 kdebase-apps)
313 KMEXTRACTONLY+="
314 config-apps.h.cmake
315 ConfigureChecks.cmake"
316 ;;
206 kdebase-runtime) 317 kdebase-runtime)
207 KMEXTRACTONLY="${KMEXTRACTONLY} 318 KMEXTRACTONLY+="
208 config-runtime.h.cmake" 319 config-runtime.h.cmake"
209 ;; 320 ;;
210 kdebase-workspace) 321 kdebase-workspace)
211 KMEXTRACTONLY="${KMEXTRACTONLY} 322 KMEXTRACTONLY+="
212 config-unix.h.cmake 323 config-unix.h.cmake
213 ConfigureChecks.cmake 324 ConfigureChecks.cmake
214 config-workspace.h.cmake 325 config-workspace.h.cmake
215 config-X11.h.cmake 326 config-X11.h.cmake
216 startkde.cmake" 327 startkde.cmake
328 KDE4WorkspaceConfig.cmake.in"
217 ;; 329 ;;
218 kdegames) 330 kdegames)
219 if [[ ${PN} != "libkdegames" ]]; then 331 if [[ ${PN} != libkdegames ]]; then
220 KMEXTRACTONLY="${KMEXTRACTONLY} 332 KMEXTRACTONLY+="
221 libkdegames" 333 libkdegames/"
334 KMLOADLIBS="${KMLOADLIBS} libkdegames"
222 fi 335 fi
223 ;; 336 ;;
337 kdepim)
338 if [[ ${PN} != libkdepim ]]; then
339 KMEXTRACTONLY+="
340 libkdepim/"
341 fi
342 KMEXTRACTONLY+="
343 config-enterprise.h.cmake
344 kleopatra/ConfigureChecks.cmake"
345 if slot_is_at_least 4.5 ${SLOT}; then
346 KMEXTRACTONLY+="
347 CTestCustom.cmake
348 kdepim-version.h.cmake"
349 else
350 KMEXTRACTONLY+="
351 kdepim-version.h"
352 fi
353 if has kontact ${IUSE//+} && use kontact; then
354 KMEXTRA+="
355 kontact/plugins/${PLUGINNAME:-${PN}}/"
356 fi
357 ;;
358 kdeutils)
359 KMEXTRACTONLY+="
360 kdeutils-version.h"
361 ;;
224 koffice) 362 koffice)
225 KMEXTRACTONLY="${KMEXTRACTONLY} 363 KMEXTRACTONLY+="
226 config-endian.h.cmake
227 filters/config-filters.h.cmake 364 filters/config-filters.h.cmake
365 "
366 case ${PV} in
367 2.0.*)
368 KMEXTRACTONLY+="
369 config-openctl.h.cmake
370 config-endian.h.cmake
228 config-openexr.h.cmake 371 config-openexr.h.cmake
229 config-opengl.h.cmake 372 config-opengl.h.cmake
230 config-prefix.h.cmake" 373 config-prefix.h.cmake"
374 ;;
375 2.[12].*)
376 KMEXTRACTONLY+="
377 config-endian.h.cmake
378 config-openexr.h.cmake
379 config-opengl.h.cmake
380 config-prefix.h.cmake"
381 ;;
382 esac
383 ;;
384 esac
385 # Don't install cmake modules for split ebuilds, to avoid collisions.
386 case ${KMNAME} in
387 kdebase-runtime|kdebase-workspace|kdeedu|kdegames|kdegraphics)
388 case ${PN} in
389 libkdegames|libkdeedu|libkworkspace)
390 KMEXTRA+="
391 cmake/modules/"
392 ;;
393 *)
394 KMCOMPILEONLY+="
395 cmake/modules/"
396 ;;
397 esac
231 ;; 398 ;;
232 esac 399 esac
233 # Don't install cmake modules for split ebuilds to avoid collisions.
234 case ${KMNAME} in
235 kdebase-workspace|kdebase-runtime|kdepim|kdegames)
236 if [[ ${PN} != "libkdegames" ]]; then
237 KMCOMPILEONLY="${KMCOMPILEONLY}
238 cmake/modules/"
239 else
240 KMEXTRA="${KMEXTRA}
241 cmake/modules/"
242 fi
243 ;;
244 esac
245 400
246 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}" 401 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME}: KMEXTRACTONLY ${KMEXTRACTONLY}"
247} 402}
248 403
249__list_needed_subdirectories() { 404__list_needed_subdirectories() {
250 local i j kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist topdir 405 local i j kmextra kmextra_expanded kmmodule_expanded kmcompileonly_expanded extractlist
251 406
252 # We expand KMEXTRA by adding CMakeLists.txt files 407 # We expand KMEXTRA by adding CMakeLists.txt files
253 for i in ${KMEXTRA}; do 408 kmextra="${KMEXTRA}"
254 kmextra_expanded="${kmextra_expanded} ${i}" 409 [[ ${1} != fatal ]] && kmextra+=" ${KMEXTRA_NONFATAL}"
410 for i in ${kmextra}; do
411 kmextra_expanded+=" ${i}"
255 j=$(dirname ${i}) 412 j=$(dirname ${i})
256 while [[ ${j} != "." ]]; do 413 while [[ ${j} != "." ]]; do
257 kmextra_expanded="${kmextra_expanded} ${j}/CMakeLists.txt"; 414 kmextra_expanded+=" ${j}/CMakeLists.txt";
258 j=$(dirname ${j}) 415 j=$(dirname ${j})
259 done 416 done
260 done 417 done
261 418
262 # Expand KMMODULE 419 # Expand KMMODULE
263 if [[ -n ${KMMODULE} ]]; then 420 if [[ -n ${KMMODULE} ]]; then
264 kmmodule_expanded="${KMMODULE}" 421 kmmodule_expanded="${KMMODULE}"
265 j=$(dirname ${KMMODULE}) 422 j=$(dirname ${KMMODULE})
266 while [[ ${j} != "." ]]; do 423 while [[ ${j} != "." ]]; do
267 kmmodule_expanded="${kmmodule_expanded} $j/CMakeLists.txt"; 424 kmmodule_expanded+=" ${j}/CMakeLists.txt";
268 j=$(dirname $j) 425 j=$(dirname ${j})
269 done 426 done
270 fi 427 fi
271 428
272 # Expand KMCOMPILEONLY 429 # Expand KMCOMPILEONLY
273 for i in ${KMCOMPILEONLY}; do 430 for i in ${KMCOMPILEONLY}; do
274 kmcompileonly_expanded="${kmcompileonly_expanded} ${i}" 431 kmcompileonly_expanded+=" ${i}"
275 j=$(dirname ${i}) 432 j=$(dirname ${i})
276 while [[ ${j} != "." ]]; do 433 while [[ ${j} != "." ]]; do
277 kmcompileonly_expanded="${kmcompileonly_expanded} ${j}/CMakeLists.txt"; 434 kmcompileonly_expanded+=" ${j}/CMakeLists.txt";
278 j=$(dirname ${j}) 435 j=$(dirname ${j})
279 done 436 done
280 done 437 done
281 438
282 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}" 439 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmextra_expanded: ${kmextra_expanded}"
283 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}" 440 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmmodule_expanded: ${kmmodule_expanded}"
284 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}" 441 debug-print "line ${LINENO} ${ECLASS} ${FUNCNAME} - kmcompileonly_expanded: ${kmcompileonly_expanded}"
285 442
286
287 case ${NEED_KDE} in
288 svn) : ;;
289 *) topdir="${KMNAME}-${PV}/" ;;
290 esac
291
292 # Create final list of stuff to extract 443 # Create final list of stuff to extract
444 # We append topdir only when specified (usually for tarballs)
293 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \ 445 for i in ${kmmodule_expanded} ${kmextra_expanded} ${kmcompileonly_expanded} \
294 ${KMEXTRACTONLY} 446 ${KMEXTRACTONLY}
295 do 447 do
296 extractlist="${extractlist} ${topdir}${i}" 448 extractlist+=" ${topdir}${moduleprefix}${i}"
297 done 449 done
298 450
299 echo ${extractlist} 451 echo ${extractlist}
300} 452}
301 453
302# @FUNCTION: kde4-meta_src_compile 454# @FUNCTION: kde4-meta_src_prepare
303# @DESCRIPTION: 455# @DESCRIPTION:
304# General function for compiling split KDE4 applications. 456# Meta-package build system configuration handling - commenting out targets, etc..
305kde4-meta_src_compile() { 457kde4-meta_src_prepare() {
306 debug-print-function ${FUNCNAME} "$@" 458 debug-print-function ${FUNCNAME} "$@"
307 459
308 kde4-meta_src_configure 460 kde4-meta_change_cmakelists
309 kde4-meta_src_make 461 kde4-base_src_prepare
310} 462}
311 463
464# FIXME: no comment here?
312_change_cmakelists_parent_dirs() { 465_change_cmakelists_parent_dirs() {
313 debug-print-function ${FUNCNAME} "$@" 466 debug-print-function ${FUNCNAME} "$@"
314 467
315 local _olddir _dir 468 local _olddir _dir
316 _dir="${S}"/${1} 469 _dir="${S}"/${1}
317 until [[ ${_dir} == "${S}" ]]; do 470 until [[ ${_dir} == "${S}" ]]; do
318 _olddir=$(basename ${_dir}) 471 _olddir=$(basename "${_dir}")
319 _dir=$(dirname ${_dir}) 472 _dir=$(dirname "${_dir}")
320 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}" 473 debug-print "${LINENO}: processing ${_dir} CMakeLists.txt searching for ${_olddir}"
321 if [[ -f ${_dir}/CMakeLists.txt ]]; then 474 if [[ -f ${_dir}/CMakeLists.txt ]]; then
322 sed -i -e "/[[:space:]]*${_olddir}[[:space:]]*/s/^#DONOTCOMPILE //" ${_dir}/CMakeLists.txt || \ 475 sed -e "/add_subdirectory[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
476 -e "/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${_olddir}[[:space:]]*)/s/#DONOTCOMPILE //g" \
323 die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}" 477 -i ${_dir}/CMakeLists.txt || die "${LINENO}: died in ${FUNCNAME} while processing ${_dir}"
324 fi 478 fi
325 done 479 done
326} 480}
327 481
482# @FUNCTION: kde4-meta_change_cmakelists
483# @DESCRIPTION:
484# Adjust CMakeLists.txt to comply to our splitting.
328kde4-meta_change_cmakelists() { 485kde4-meta_change_cmakelists() {
329 debug-print-function ${FUNCNAME} "$@" 486 debug-print-function ${FUNCNAME} "$@"
330 487
331 pushd "${S}" > /dev/null 488 pushd "${S}" > /dev/null
332 489
333 comment_all_add_subdirectory ./ 490 comment_all_add_subdirectory ./
334 491
335 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt 492 # Restore "add_subdirectory( cmake )" in ${S}/CMakeLists.txt
336 if [[ -f "${S}"/CMakeLists.txt ]]; then 493 if [[ -f CMakeLists.txt ]]; then
337 sed -i -e '/ *cmake */s/^#DONOTCOMPILE //' "${S}"/CMakeLists.txt || die "${LINENO}: cmake sed died" 494 sed -e '/add_subdirectory[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
495 -e '/ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*cmake[[:space:]]*)/s/^#DONOTCOMPILE //' \
496 -i CMakeLists.txt || die "${LINENO}: cmake sed died"
338 fi 497 fi
339 498
340 if [[ -z ${KMNOMODULE} ]]; then 499 if [[ -z ${KMNOMODULE} ]]; then
341 # Restore "add_subdirectory" in $KMMODULE subdirectories 500 # Restore "add_subdirectory" in $KMMODULE subdirectories
342 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 501 find "${S}"/${KMMODULE} -name CMakeLists.txt -print0 | \
502 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
343 die "${LINENO}: died in KMMODULE section" 503 die "${LINENO}: died in KMMODULE section"
344 _change_cmakelists_parent_dirs ${KMMODULE} 504 _change_cmakelists_parent_dirs ${KMMODULE}
345 fi 505 fi
346 506
507 local i
508
509 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
510 for i in ${KMEXTRACTONLY}; do
511 if [[ -d ${i} && -f ${i}/../CMakeLists.txt ]]; then
512 sed -e "/([[:space:]]*$(basename $i)[[:space:]]*)/s/^/#DONOTCOMPILE /" \
513 -i ${i}/../CMakeLists.txt || \
514 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
515 fi
516 done
517
347 # KMCOMPILEONLY 518 # KMCOMPILEONLY
348 local i
349 for i in ${KMCOMPILEONLY}; do 519 for i in ${KMCOMPILEONLY}; do
350 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}" 520 debug-print "${LINENO}: KMCOMPILEONLY, processing ${i}"
351 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions. 521 # Uncomment "add_subdirectory" instructions inside $KMCOMPILEONLY, then comment "install" instructions.
352 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 522 find "${S}"/${i} -name CMakeLists.txt -print0 | \
353 xargs -0 sed -i \ 523 xargs -0 sed -i \
360 done 530 done
361 531
362 # KMEXTRA section 532 # KMEXTRA section
363 for i in ${KMEXTRA}; do 533 for i in ${KMEXTRA}; do
364 debug-print "${LINENO}: KMEXTRA section, processing ${i}" 534 debug-print "${LINENO}: KMEXTRA section, processing ${i}"
365 # Ebuilds use KMEXTRA incorrectly to extract files which should be in $KMEXTRACTONLY 535 find "${S}"/${i} -name CMakeLists.txt -print0 | \
536 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
537 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
538 _change_cmakelists_parent_dirs ${i}
539 done
540 # KMEXTRA_NONFATAL section
541 for i in ${KMEXTRA_NONFATAL}; do
366 if [[ -d "${S}"/${i} ]]; then 542 if [[ -d "${S}"/${i} ]]; then
367 find "${S}"/${i} -name CMakeLists.txt -print0 | \ 543 find "${S}"/${i} -name CMakeLists.txt -print0 | \
368 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \ 544 xargs -0 sed -i -e 's/^#DONOTCOMPILE //g' || \
369 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}" 545 die "${LINENO}: sed died uncommenting add_subdirectory instructions in KMEXTRA section while processing ${i}"
370 _change_cmakelists_parent_dirs ${i} 546 _change_cmakelists_parent_dirs ${i}
371 else
372 [[ ${i} == doc/* ]] || \
373 die "KMEXTRA should be used to compile and install subdirectories other than \$KMMODULE. Use KMEXTRACTONLY to extract some files."
374 fi
375 done
376
377 # Documentation section
378 if [[ -n ${docs} ]]; then
379 sed -i -e '/ *doc */s/^#DONOTCOMPILE //g' "${S}"/CMakeLists.txt || \
380 die "${LINENO}: sed died while uncommenting doc dir"
381
382 if [[ -f "${S}"/doc/CMakeLists.txt ]]; then
383 sed -i -e "/( *${KMMODULE##*/} *)/s/^#DONOTCOMPILE //g" "${S}"/doc/CMakeLists.txt \
384 || die "${LINENO}: sed died while uncommenting apps documentation in doc subdir "
385 fi
386 fi 547 fi
387
388 # KMEXTRACTONLY section - Some ebuilds need to comment out some subdirs in KMMODULE and they use KMEXTRACTONLY
389 for i in ${KMEXTRACTONLY}; do
390 if [[ -d "${S}"/${i} && -f "${S}"/${i}/../CMakeLists.txt ]]; then
391 sed -i -e "/( *$(basename $i) *)/s/^/#DONOTCOMPILE /" "${S}"/${i}/../CMakeLists.txt || \
392 die "${LINENO}: sed died while working in the KMEXTRACTONLY section while processing ${i}"
393 fi
394 done 548 done
395 549
396 # COLLISION PROTECT section
397 # Only install the startkde script as part of kde-base/kdebase-startkde,
398 # instead of with every package.
399 case ${KMNAME} in 550 case ${KMNAME} in
400 kdebase-workspace) 551 kdebase-workspace)
552 # COLLISION PROTECT section
553 # Install the startkde script just once, as a part of kde-base/kdebase-startkde,
554 # not as a part of every package.
401 if [[ ${PN} != "kdebase-startkde" && -f "${S}"/CMakeLists.txt ]]; then 555 if [[ ${PN} != kdebase-startkde && -f CMakeLists.txt ]]; then
556 # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0.
557 sed -e '/startkde/s/^/#DONOTINSTALL /' \
558 -i CMakeLists.txt || die "${LINENO}: sed died in the kdebase-startkde collision prevention section"
559 fi
560 # Strip EXPORT feature section from workspace for KDE4 versions > 4.1.82
561 if [[ ${PN} != libkworkspace ]]; then
562 sed -e '/install(FILES ${CMAKE_CURRENT_BINARY_DIR}\/KDE4WorkspaceConfig.cmake/,/^[[:space:]]*FILE KDE4WorkspaceLibraryTargets.cmake )[[:space:]]*^/d' \
563 -i CMakeLists.txt || die "${LINENO}: sed died in kdebase-workspace strip config install and fix EXPORT section"
564 fi
565 ;;
566 kdebase-runtime)
567 # COLLISION PROTECT section
568 # Only install the kde4 script as part of kde-base/kdebase-data
569 if [[ ${PN} != kdebase-data && -f CMakeLists.txt ]]; then
570 sed -e '/^install(PROGRAMS[[:space:]]*[^[:space:]]*\/kde4[[:space:]]/s/^/#DONOTINSTALL /' \
571 -i CMakeLists.txt || die "Sed to exclude bin/kde4 failed"
572 fi
573 ;;
574 kdenetwork)
575 # Disable hardcoded kdepimlibs check
576 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
577 -i CMakeLists.txt || die "failed to disable hardcoded checks"
578 ;;
579 kdepim)
580 # Disable hardcoded checks
581 sed -r -e '/find_package\(KdepimLibs/s/REQUIRED//' \
582 -e '/find_package\((KdepimLibs|Boost|QGpgme|Akonadi|ZLIB|Strigi|SharedDesktopOntologies|Soprano|Nepomuk)/{/macro_optional_/!s/find/macro_optional_&/}' \
583 -e '/macro_log_feature\((Boost|QGPGME|Akonadi|ZLIB|STRIGI|SHAREDDESKTOPONTOLOGIES|Soprano|Nepomuk)_FOUND/s/ TRUE / FALSE /' \
584 -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
585 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
586 -i CMakeLists.txt || die "failed to disable hardcoded checks"
587 # Disable broken or redundant build logic
588 if ( has kontact ${IUSE//+} && use kontact ) || [[ ${PN} = kontact ]]; then
589 sed -e '/if[[:space:]]*([[:space:]]*BUILD_.*)/s/^/#OVERRIDE /' \
590 -e '/if[[:space:]]*([[:space:]]*[[:alnum:]]*_FOUND[[:space:]]*)/s/^/#OVERRIDE /' \
591 -i kontact/plugins/CMakeLists.txt || die 'failed to override build logic'
592 fi
593 if ! slot_is_at_least 4.5 ${SLOT}; then
594 case ${PN} in
595 kalarm|kmailcvt|kontact|korganizer|korn)
596 sed -n -e '/qt4_generate_dbus_interface(.*org\.kde\.kmail\.\(kmail\|mailcomposer\)\.xml/p' \
597 -e '/add_custom_target(kmail_xml /,/)/p' \
598 -i kmail/CMakeLists.txt || die "uncommenting xml failed"
599 _change_cmakelists_parent_dirs kmail
600 ;;
601 esac
602 fi
603 ;;
604 kdewebdev)
605 # Disable hardcoded checks
606 sed -e 's/find_package(KdepimLibs REQUIRED)/macro_optional_find_package(KdepimLibs)/' \
607 -e 's/find_package(LibXml2 REQUIRED)/macro_optional_find_package(LibXml2)/' \
608 -e 's/find_package(LibXslt REQUIRED)/macro_optional_find_package(LibXslt)/' \
609 -e 's/find_package(Boost REQUIRED)/macro_optional_find_package(Boost)/' \
610 -i CMakeLists.txt || die "failed to disable hardcoded checks"
611 ;;
612 koffice)
613 # Prevent collisions
614 if [[ ${PN} != koffice-data ]]; then
615 sed -e '/install(.*FindKOfficeLibs.cmake/,/)/ d' \
616 -i cmake/modules/CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
617 sed -e '/install(.\+config-openexr\.h.\+)/d' \
618 -i CMakeLists.txt || die "${LINENO}: sed died in collision prevention section"
619 fi
620 # koffice 2.0
402 case ${PV} in 621 case ${PV} in
403 *) # The startkde script moved to kdebase-workspace for KDE4 versions > 3.93.0. 622 2.0.[1-9])
404 sed -i -e '/startkde/s/^/#DONOTINSTALL /' "${S}"/CMakeLists.txt || \ 623 sed -i -n -e '1h;1!H;${g;s/install(.\+config-openexr.h.\+)//;p}' \
624 "${S}"/CMakeLists.txt || \
405 die "${LINENO}: sed died in the kdebase-startkde collision prevention section" 625 die "${LINENO}: sed died in collision prevention section"
406 ;; 626 ;;
627 *) ;;
407 esac 628 esac
408 fi 629 # koffice 2.1.[8-9][0-9] and 9999
630 case ${PV} in
631 2.1.8[0-9]|2.1.9[0-9]|9999)
632 sed -e '/^option(BUILD/s/ON/OFF/' \
633 -e '/^if(NOT BUILD_kchart/,/^endif(NOT BUILD_kchart/d' \
634 -e '/^if(BUILD_koreport/,/^endif(BUILD_koreport/d' \
635 -e 's/set(SHOULD_BUILD_F_OFFICE TRUE)/set(SHOULD_BUILD_F_OFFICE FALSE)/' \
636 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
637 if [[ ${PN} != koffice-data ]] && [[ ${PV} == 9999 ]]; then
638 sed -e '/config-opengl.h/d' \
639 -i "${S}"/CMakeLists.txt || die "sed died while fixing cmakelists"
640
641 fi
409 ;; 642 ;;
410 # This is sort of a hack to avoid patching 16 kdeutils packages with 643 *) ;;
411 # r775410 from upstream trunk which makes blitz optional so superkaramba 644 esac
412 # only gets compiled when it is found. Bug #209324. Remove this no later
413 # than 4.1.
414 kdeutils)
415 if [[ ${PN} != superkaramba && ${SLOT} == kde-4 ]]; then
416 sed -i -e '/find_package(Blitz REQUIRED)/d' "${S}"/CMakeLists.txt \
417 || die "${LINENO}: sed to remove dependency on Blitz failed."
418 fi
419 ;;
420 koffice)
421 if [[ ${PN} != koffice-libs ]]; then
422 sed -i -e '/^INSTALL(FILES.*koffice.desktop/ s/^/#DONOTINSTALL /' \
423 doc/CMakeLists.txt || \
424 die "${LINENO}: sed died in the koffice.desktop collision prevention section"
425 fi
426 ;;
427 esac 645 esac
428 646
429 popd > /dev/null 647 popd > /dev/null
430} 648}
431 649
432# @FUNCTION: kde4-meta_src_configure 650# @FUNCTION: kde4-meta_src_configure
433# @DESCRIPTION: 651# @DESCRIPTION:
434# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 652# Currently just calls its equivalent in kde4-base.eclass(5). Use this one in split
435# ebuilds. 653# ebuilds.
436kde4-meta_src_configure() { 654kde4-meta_src_configure() {
437 debug-print-function ${FUNCNAME} "$@" 655 debug-print-function ${FUNCNAME} "$@"
656
657 # backwards-compatibility: make mycmakeargs an array, if it isn't already
658 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
659 mycmakeargs=(${mycmakeargs})
660 fi
661
662 # Set some cmake default values here (usually workarounds for automagic deps)
663 case ${KMNAME} in
664 kdewebdev)
665 mycmakeargs=(
666 -DWITH_KdepimLibs=OFF
667 -DWITH_LibXml2=OFF
668 -DWITH_LibXslt=OFF
669 -DWITH_Boost=OFF
670 -DWITH_LibTidy=OFF
671 "${mycmakeargs[@]}"
672 )
673 ;;
674 koffice)
675 case ${PV} in
676 2.1.8[0-9]|2.1.9[0-9]|9999)
677 if [[ ${PN} != "kchart" ]]; then
678 mycmakeargs=(
679 -DBUILD_koreport=OFF
680 "${mycmakeargs[@]}"
681 )
682 fi
683 ;;
684 esac
685 ;;
686 esac
438 687
439 kde4-base_src_configure 688 kde4-base_src_configure
440} 689}
441 690
442# @FUNCTION: kde4-meta_src_make 691# @FUNCTION: kde4-meta_src_compile
443# @DESCRIPTION: 692# @DESCRIPTION:
444# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 693# General function for compiling split KDE4 applications.
445# ebuilds. 694# Overrides kde4-base_src_compile.
446kde4-meta_src_make() { 695kde4-meta_src_compile() {
447 debug-print-function ${FUNCNAME} "$@" 696 debug-print-function ${FUNCNAME} "$@"
448 697
449 kde4-base_src_make 698 kde4-base_src_compile "$@"
450} 699}
451 700
452# @FUNCTION: kde4-meta_src_test 701# @FUNCTION: kde4-meta_src_test
453# @DESCRIPTION: 702# @DESCRIPTION:
454# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 703# Currently just calls its equivalent in kde4-base.eclass(5) if
455# ebuilds. 704# I_KNOW_WHAT_I_AM_DOING is set. Use this in split ebuilds.
456kde4-meta_src_test() { 705kde4-meta_src_test() {
457 debug-print-function $FUNCNAME "$@" 706 debug-print-function $FUNCNAME "$@"
458 707
708 if [[ $I_KNOW_WHAT_I_AM_DOING ]]; then
459 kde4-base_src_test 709 kde4-base_src_test
710 else
711 einfo "Tests disabled"
712 fi
460} 713}
461 714
462# @FUNCTION: kde4-meta_src_install 715# @FUNCTION: kde4-meta_src_install
463# @DESCRIPTION: 716# @DESCRIPTION:
464# Function for installing KDE4 split applications. 717# Function for installing KDE4 split applications.
465kde4-meta_src_install() { 718kde4-meta_src_install() {
466 debug-print-function $FUNCNAME "$@" 719 debug-print-function $FUNCNAME "$@"
467 720
468 kde4-meta_src_make_doc 721 # Search ${S}/${KMMODULE} and install common documentation files found
469 cmake-utils_src_install
470}
471
472# @FUNCTION: kde4-meta_src_make_doc
473# @DESCRIPTION:
474# This function searches under ${S}/${KMMODULE},
475# and tries to install "AUTHORS ChangeLog* README* NEWS todo" if these files exist.
476kde4-meta_src_make_doc() {
477 debug-print-function $FUNCNAME "$@"
478
479 local doc 722 local doc
480 for doc in AUTHORS ChangeLog* README* NEWS TODO; do 723 for doc in "${S}/${KMMODULE}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
481 [[ -s ${KMMODULE}/$doc ]] && newdoc "${KMMODULE}/${doc}" "${doc}.${KMMODULE##*/}" 724 [[ -f "${doc}" ]] && [[ -s "${doc}" ]] && dodoc "${doc}"
482 done 725 done
483 726
484 kde4-base_src_make_doc 727 kde4-base_src_install
485} 728}
486 729
487# @FUNCTION: kde4-meta_pkg_postinst 730# @FUNCTION: kde4-meta_pkg_postinst
488# @DESCRIPTION: 731# @DESCRIPTION:
489# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 732# Invoke kbuildsycoca4.
490# ebuilds.
491kde4-meta_pkg_postinst() { 733kde4-meta_pkg_postinst() {
734 debug-print-function ${FUNCNAME} "$@"
735
492 kde4-base_pkg_postinst 736 kde4-base_pkg_postinst
493} 737}
494 738
495# @FUNCTION: kde4-meta_pkg_postrm 739# @FUNCTION: kde4-meta_pkg_postrm
496# @DESCRIPTION: 740# @DESCRIPTION:
497# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split 741# Currently just calls its equivalent in kde4-base.eclass(5). Use this in split
498# ebuilds. 742# ebuilds.
499kde4-meta_pkg_postrm() { 743kde4-meta_pkg_postrm() {
744 debug-print-function ${FUNCNAME} "$@"
745
500 kde4-base_pkg_postrm 746 kde4-base_pkg_postrm
501} 747}

Legend:
Removed from v.1.3  
changed lines
  Added in v.1.46

  ViewVC Help
Powered by ViewVC 1.1.20